@ECHO OFF
REM %DOORSOS%\a68k\a68k %1.asm -g -t -i%DOORSOS%
REM if not exist %1.o goto error1
REM %DOORSOS%\bin\link %1.o
REM del %1.o > nul
REM if ERRORLEVEL 1 goto zerror1
REM goto end
REM :zerror1
REM echo There were errors.
REM :end

REM **** Hopefully this will help some newbies ****
REM ANSI prompts take lots of enviornment space.


If not exist c:\config.sys goto nocfg
@find "ansi.sys" c:\config.sys > nul
@if not errorlevel 1 goto ansi
:nocfg


IF %1. == . GOTO Znoinput
IF NOT %2. == . GOTO Ztoomuch
IF not exist %1.asm GOTO Zasmnotfound
IF "%doorsos%" == "" GOTO ZnEVdoors

IF EXIST %1.o GOTO Zobjhere

IF NOT EXIST %doorsos%\a68k\a68k.exe GOTO Zerror2
IF NOT EXIST %doorsos%\BIN\link.exe GOTO Zerror3
:zcompile
@ECHO a68k.exe %1.asm -g -t -i%DOORSOS%
CALL %DOORSOS%\a68k\a68k.exe %1.asm -g -t -i%DOORSOS%
if not exist %1.o goto zerror1
:zlink
@echo.
@ECHO link.exe %1.o
%DOORSOS%\BIN\link.exe %1.o
del %1.o > nul
if ERRORLEVEL 1 goto zerror1
echo.
ECHO SUCCESS
goto zend
:zlink2
@echo.
@ECHO link.exe %1.o
CALL %DOORSOS%\BIN\link.exe %1.o
del /p %1.o > nul
echo.
goto zend

:zerror1
@echo.
@echo There were errors.
GOTO zend

:ztoomuch
@echo Too many parameters. (%2 %3 %4 %5)
:znoinput
@Echo DOORS.BAT
@echo.
@echo Compiles and links '.ASM' files for use in TI Calculators running DoorsOs.
@echo.
@echo Usage: 'DOORS [asmfile]'
@echo Creates: '[asmfile].89z' and or '[asmfile].9xz' calculator files.
@echo.
@echo By doing: %%DOORSOS%%\a68k\a68k.exe %%1.asm -g -t -i%%DOORSOS%%
@echo  -g causes any undefined symbols to be treated as if they were
@echo     externally defined (XREF), rather than being flagged as errors.
@echo  -t allows tabs in the source file to be passed through to the
@echo     listing file, rather than being expanded. more...
@echo  -i specifies directories to be searched for INCLUDE files in
@echo     addition to the current directory. more...
@echo And:  %%DOORSOS%%\BIN\link.exe %%1.o
@echo.
@echo  Additional Batch File features by happy_cobbler@bigfoot.com
@echo  Your computer must boot with ANSI.sys in the config.sys
@echo  inorder to see the color.
@echo.
@echo You could Add the following lines to your AUTOEXEC.BAT: 
@echo    SET DOORSOS=[PathOfDoors]
@echo    PATH=[PathOfDoors];%%PATH%%

GOTO zend

REM no Environment Variable doorsos
:znEVdoors

@ECHO  You must type 'SET DOORSOS=[path]'
@ECHO  before using this batch file.

REM Goto zcompile
GOTO zend

:zasmnotfound
@echo.
@ECHO FILE NOT FOUND [%1%.asm]
@echo.
@IF EXIST %1.o GOTO zobjhere
:zohwell
@ECHO REMEMBER: DON'T include the '.asm'!
@ECHO Also: The working directory should be the directory that contains the file you
@ECHO want to compile.
goto zend
:zerror2
echo A68K.EXE not found.
echo And maybe
GOTO zskipper
:zerror3
:zskipper
echo LINK.EXE not found.
echo.
echo Maybe %%doorsos%% is set incorrectly? Type 'SET' to find out.

IF NOT EXIST C:\windows\command\choice.com GOTO zohwell
echo Atempt: [L] Link [C] Compile Or:[A] Abort [S] SET command
C:\windows\command\choice.com /CLCAS  Enter your selection.
IF ERRORLEVEL 4 SET
IF ERRORLEVEL 3 GOTO zend
IF ERRORLEVEL 2 GOTO zcompile
IF ERRORLEVEL 1 GOTO zlink2

goto zend

:zobjhere
ECHO Object file '%1.o' found.
IF NOT EXIST C:\windows\command\choice.com GOTO zcompile
echo [L] Link  [C] Compile the asm file then link [A] Abort
C:\windows\command\choice.com /CLCA  Enter your selection.
IF ERRORLEVEL 3 GOTO zend
IF ERRORLEVEL 2 GOTO zcompile
IF ERRORLEVEL 1 GOTO zlink2
goto zend
:zend
@echo.
goto exit

REM Doors.bat v2 beta with color for ansi.sys users
REM Aaron Peterson
REM happy_cobbler@bigfoot.com

REM ******************************************************
goto exit
:ansi
IF %1. == . GOTO noinput
IF NOT %2. == . GOTO toomuch
IF not exist %1.asm GOTO asmnotfound
IF "%doorsos%" == "" GOTO nEVdoors

IF EXIST %1.o GOTO objhere

IF NOT EXIST %doorsos%\a68k\a68k.exe GOTO error2
IF NOT EXIST %doorsos%\BIN\link.exe GOTO error3
:compile
@echo on
@prompt=$e[1;34m$e[1A

@ECHO %DOORSOS%\a68k\a68k.exe %1.asm -g -t -i%DOORSOS%
@prompt=$e[1;36m$e[1A$e[1A

@echo off
CALL %DOORSOS%\a68k\a68k.exe %1.asm -g -t -i%DOORSOS%
if not exist %1.o goto error1
:link
@echo on
@prompt=$e[1;34m$e[1A

@ECHO %DOORSOS%\BIN\link.exe %1.o
@prompt=$e[1;32m$e[1A$e[1A

@echo off
%DOORSOS%\BIN\link.exe %1.o
@echo off
del %1.o > nul
if ERRORLEVEL 1 goto error1
@echo on
@prompt=$e[1;34m$e[1A

@echo off
ECHO SUCCESS
goto end
:link2
@echo on
@prompt=$e[1;34m

@ECHO %DOORSOS%\BIN\link.exe %1.o
@prompt=$e[1;32m

@echo off
%DOORSOS%\BIN\link.exe %1.o
@echo on
@prompt=$e[1;33m
del /p %1.o

@prompt=$e[1;34m

@echo off
ECHO.
goto end


goto end
:error1
@prompt=$e[1;33m
@echo on

@echo off
@echo There were errors.
GOTO end

:toomuch
@echo Too many parameters. (%2 %3 %4 %5)
:noinput
@echo on
@prompt=$e[1;37m$e[1A

@prompt=$e[1;36m$e[1A
@Echo DOORS.BAT

@echo Compiles and links '.ASM' files for use in TI Calculators running DoorsOs.

@prompt=$e[1;34m$e[1A
@echo Usage: 'DOORS [asmfile]'
@echo Creates: '[asmfile].89z' and or '[asmfile].9xz' calculator files.

@prompt=$e[1;31m$e[1A
@echo By doing: %%DOORSOS%%\a68k\a68k.exe %%1.asm -g -t -i%%DOORSOS%%
@echo  -g causes any undefined symbols to be treated as if they were
@echo     externally defined (XREF), rather than being flagged as errors.
@echo  -t allows tabs in the source file to be passed through to the
@echo     listing file, rather than being expanded. more...
@echo  -i specifies directories to be searched for INCLUDE files in
@echo     addition to the current directory. more...
@echo And:  %%DOORSOS%%\BIN\link.exe %%1.o

@echo  Additional Batch File features by happy_cobbler@bigfoot.com
@echo  Your computer must boot with ANSI.sys in the config.sys
@echo  inorder to see color.
@prompt=$e[1;33m$e[1A

@echo You could Add the following lines to your AUTOEXEC.BAT: 
@echo    SET DOORSOS=[PathOfDoors]
@echo    PATH=[PathOfDoors];%%PATH%%
@echo off
GOTO end

REM no Environment Variable doorsos
:nEVdoors
@prompt=$e[1;33m$e[1A
@echo on

@ECHO  You must type 'SET DOORSOS=[path]'
@ECHO  before using this batch file.
@echo off
REM Goto compile
GOTO end

:asmnotfound
@prompt=$e[1;33m$e[1A
@echo on

@ECHO FILE NOT FOUND [%1%.asm]

@IF EXIST %1.o GOTO objhere
:ohwell
@prompt=$e[1;31m$e[1A

@ECHO REMEMBER: DON'T include the '.asm'!
@ECHO Also: The working directory should be the directory that contains the file you
@ECHO want to compile.
@echo off
goto end
:error2
@prompt=$e[1;33m$e[1A
@echo on

@echo off
echo A68K.EXE not found.
echo And maybe
GOTO skipper
:error3
@prompt=$e[1;33m$e[1A
@echo on

@echo off
:skipper
echo LINK.EXE not found.
echo Maybe %%doorsos%% is set incorrectly? Type 'SET' to find out.
IF NOT EXIST C:\windows\command\choice.com GOTO ohwell
echo Atempt: [L] Link [C] Compile Or:[A] Abort [S] SET command
C:\windows\command\choice.com /CLCAS  Enter your selection.
IF ERRORLEVEL 4 SET
IF ERRORLEVEL 3 GOTO end
IF ERRORLEVEL 2 GOTO compile
IF ERRORLEVEL 1 GOTO link2
goto end

:objhere
@echo on
@prompt=$e[1;31m$e[1A

@echo off
ECHO Object file '%1.o' found.
IF NOT EXIST C:\windows\command\choice.com GOTO compile
echo [L] Link  [C] Compile the asm file then link [A] Abort
C:\windows\command\choice.com /CLCA  Enter your selection.
IF ERRORLEVEL 3 GOTO end
IF ERRORLEVEL 2 GOTO compile
IF ERRORLEVEL 1 GOTO link2
goto end
:end
@prompt=$e[0;37m$e[1A$e[1A
@echo on

@echo off
@prompt=$p$g
goto exit

REM Doors.bat v2 beta with color for ansi.sys users
REM Aaron Peterson
REM happy_cobbler@bigfoot.com
:exit

